/******************************************************************************/
/*                        -- ڰſɿƼ޹˾ --                        */
/*
//  ļ                                                              
//  ˵                                                                  
//  дԱ                                                                   
//  дڣ                                                              
//  ά
//  ά¼
//
//                                                          
*/ 
// óѧϰ뽻 
// (c) Anxinke Corporation. All rights reserved.                                                               
/******************************************************************************/
#include "typedef.h"
#include <intrins.h>
#include <string.h>
#include "NRF_24L01.h"
#include "UART.H"
#include "delay.h"
#define UINT8 unsigned char
#define uchar unsigned char
#define INT8  unsigned int
uchar const TX_ADDRESS[TX_ADR_WIDTH]  = {0x34,0x43,0x10,0x10,0x01}; // Define a static TX address
//#define bk2423
/**************************************************/
//sbit LED1= P3^7;
/**************************************************/
unsigned char	bdata sta;

sbit	RX_DR	=sta^6;

sbit	TX_DS	=sta^5;

sbit	MAX_RT	=sta^4;
/**************************************************/

/**************************************************
Function: init_io();
Description:
  flash led one time,chip enable(ready to TX or RX Mode),
  Spi disable,Spi clock line init high
/**************************************************/
uchar SPI_RW(uchar byte)
{
	uchar bit_ctr;
   	for(bit_ctr=0;bit_ctr<8;bit_ctr++)   // output 8-bit
   	{
   		MOSI = (byte & 0x80);         // output 'byte', MSB to MOSI
   		byte = (byte << 1);           // shift next bit into MSB..
   		SCK = 1;                      // Set SCK high..
		MISO=1;
   		byte |= MISO;       		  // capture current MISO bit
   		SCK = 0;            		  // ..then set SCK low again
   	}
    return(byte);           		  // return read byte
}

unsigned char op_status;

//Bank1 register initialization value

//In the array Bank1_Reg0_13,all[] the register value is the byte reversed!!!!!!!!!!!!!!!!!!!!!
code unsigned long Bank1_Reg0_13[]={       
0xE2014B40,
0x00004BC0,
0x028CFCD0,
0x413900f9,
0x0B84BEf9,  //high sensitivity mode, to enable normal sensitivity mode,use 0x0B869ED9
0xA67F0624,  //RSSI measurement disabled, to enable RSSI measurement,use 0xA67F0224
0x00000000,
0x00000000,
0x00000000,
0x00000000,
0x00000000,
0x00000000,
0x00107305,
0x36B48000,
};
code unsigned char Bank1_Reg14[]=
{
0x41,0x10,0x04,0x82,0x20,0x08,0x08,0xF2,0x7D,0xEF,0xFF
};

//Bank0 register initialization value
code unsigned char Bank0_Reg[][2]={
{0,0x0F},//congig
{1,0x03},//en_aa
{2,0x03},//en_rxaddr
{3,0x03},//setup_aw
{4,0x15},//setup_retr
{5,40},//rf_ch
{6,0X07},//rf_setup	//REG6,120517,0x0F or 0x2F:2Mbps; 0x07:1Mbps ; 0x27:250Kbps
{7,0x07},//status
{8,0x00},//observe_tx
{9,0x00},//cd

{12,0x11},//rx_addr_p2
{13,0x12},//rx_addr_p3
{14,0x13},//rx_addr_p4
{15,0x14},//rx_addr_p5

{17,0x20},//RX_PW_P0
{18,0x20},//RX_PW_P1
{19,0x20},//RX_PW_P2
{20,0x20},//RX_PW_P3
{21,0x20},//RX_PW_P4
{22,0x20},//RX_PW_P5

{23,0x00},//FIFO_STATUS,
{28,0x3F},//DYNPD
{29,0x04}, //FEATURE
};



code unsigned char RX0_Address[]={0x34,0x43,0x10,0x10,0x01};
code unsigned char RX1_Address[]={0x10,0x56,0x24,0xCD,0x78};

/**************************************************/

/**************************************************
Function: SPI_RW_Reg();

Description:
  Writes value 'value' to register 'reg'
/**************************************************/
uchar SPI_RW_Reg(BYTE reg, BYTE value)
{
	uchar status;
  	CSN = 0;                   // CSN low, init SPI transaction
  	status = SPI_RW(reg);      // select register
  	SPI_RW(value);             // ..and write value to it..
  	CSN = 1;                   // CSN high again
  	return(status);            // return nRF24L01 status byte
}
/**************************************************/        
                                                            
/**************************************************         
Function: SPI_Write_Reg();                                  
                                                            
Description:                                                
	Writes value 'value' to register 'reg'              
/**************************************************/        
void SPI_Write_Reg(UINT8 reg, UINT8 value)                 
{
	CSN = 0;                   // CSN low, init SPI transaction
	op_status = SPI_RW(reg);      // select register
	SPI_RW(value);             // ..and write value to it..
	CSN = 1;                   // CSN high again
}  

/**************************************************         
Function: SPI_Read_Reg();                                   
                                                            
Description:                                                
	Read one UINT8 from BK2423 register, 'reg'           
/**************************************************/        
UINT8 SPI_Read_Reg(UINT8 reg)                               
{                                                           
	UINT8 value;
	CSN = 0;                // CSN low, initialize SPI communication...
	op_status=SPI_RW(reg);            // Select register to read from..
	value = SPI_RW(0);    // ..then read register value
	CSN = 1;                // CSN high, terminate SPI communication

	return(value);        // return register value
}            
/**************************************************/

/**************************************************
Function: SPI_Read();

Description:
  Read one byte from nRF24L01 register, 'reg'
/**************************************************/
BYTE SPI_Read(BYTE reg)
{
	BYTE reg_val;

  	CSN = 0;                // CSN low, initialize SPI communication...
  	SPI_RW(reg);            // Select register to read from..
  	reg_val = SPI_RW(0);    // ..then read registervalue
  	CSN = 1;                // CSN high, terminate SPI communication

  	return(reg_val);        // return register value
}
/**************************************************/

/**************************************************
Function: SPI_Read_Buf();

Description:
  Reads 'bytes' #of bytes from register 'reg'
  Typically used to read RX payload, Rx/Tx address
/**************************************************/
uchar SPI_Read_Buf(BYTE reg, BYTE *pBuf, BYTE bytes)
{
	uchar status,byte_ctr;

  	CSN = 0;                    		// Set CSN low, init SPI tranaction
  	status = SPI_RW(reg);       		// Select register to write to and read status byte

  	for(byte_ctr=0;byte_ctr<bytes;byte_ctr++)
    	pBuf[byte_ctr] = SPI_RW(0);    // Perform SPI_RW to read byte from nRF24L01

  	CSN = 1;                           // Set CSN high again

  	return(status);                    // return nRF24L01 status byte
}

/**************************************************/

/**************************************************
Function: SPI_Write_Buf();

Description:
  Writes contents of buffer '*pBuf' to nRF24L01
  Typically used to write TX payload, Rx/Tx address
/**************************************************/
uchar SPI_Write_Buf(BYTE reg, BYTE *pBuf, BYTE bytes)
{
	uchar status,byte_ctr;

  	CSN = 0;                   // Set CSN low, init SPI tranaction
  	status = SPI_RW(reg);    // Select register to write to and read status byte
  	for(byte_ctr=0; byte_ctr<bytes; byte_ctr++) // then write all byte in buffer(*pBuf)
    	SPI_RW(*pBuf++);
  	CSN = 1;                 // Set CSN high again
  	return(status);          // return nRF24L01 status byte
}

/**************************************************/

/**************************************************
Function: RX_Mode();

Description:
  This function initializes one nRF24L01 device to
  RX Mode, set RX address, writes RX payload width,
  select RF channel, datarate & LNA HCURR.
  After init, CE is toggled high, which means that
  this device is now ready to receive a datapacket.
/**************************************************/
void SwitchToRxMode()
{
	xdata UINT8 value;

	SPI_Write_Reg(FLUSH_RX,0);//flush Rx

	value=SPI_Read_Reg(STATUS);	// read register STATUS's value
	SPI_Write_Reg(WRITE_REG|STATUS,value);// clear RX_DR or TX_DS or MAX_RT interrupt flag

	CE=0;

	value=SPI_Read_Reg(CONFIG);	// read register CONFIG's value
//PRX
	value=value|0x01;//set bit 1
  	SPI_Write_Reg(WRITE_REG | CONFIG, value); // Set PWR_UP bit, enable CRC(2 length) & Prim:RX. RX_DR enabled..

	CE=1;
}

/**************************************************
Function: SwitchToTxMode();
Description:
	switch to Tx mode
/**************************************************/
void SwitchToTxMode()
{
	xdata UINT8 value;
	SPI_Write_Reg(FLUSH_TX,0);//flush Tx

	CE=0;
	value=SPI_Read_Reg(CONFIG);	// read register CONFIG's value
//PTX
	value=value&0xfe;//set bit 1
  	SPI_Write_Reg(WRITE_REG | CONFIG, value); // Set PWR_UP bit, enable CRC(2 length) & Prim:RX. RX_DR enabled.

	CE=1;
}
void SwitchCFG(char _cfg)//1:Bank1 0:Bank0
{
	UINT8 Tmp;

	Tmp=SPI_Read_Reg(7);
	Tmp=Tmp&0x80;

	if( ( (Tmp)&&(_cfg==0) )
	||( ((Tmp)==0)&&(_cfg) ) )
	{
		SPI_Write_Reg(ACTIVATE_CMD,0x53);
	}
}
void SetChannelNum(UINT8 ch)
{
	SPI_Write_Reg((UINT8)(WRITE_REG|5),(UINT8)(ch));
}

void BK2423_Initialize()
{
	INT8 j;
	int i;
 	UINT8 WriteArr[4];
	//DelayMs(100);//delay more than 50ms.
	Delay100ms();
	#ifdef bk2423
	SwitchCFG(0);
	#endif
//********************Write Bank0 register******************
	for(i=20;i>=0;i--)
	SPI_Write_Reg((WRITE_REG|Bank0_Reg[i][0]),Bank0_Reg[i][1]);
//reg 10 - Rx0 addr
	SPI_Write_Buf((WRITE_REG|10),RX0_Address,5);
//REG 11 - Rx1 addr
	SPI_Write_Buf((WRITE_REG|11),RX1_Address,5);
//REG 16 - TX addr
	SPI_Write_Buf((WRITE_REG|16),RX0_Address,5);

	i=SPI_Read_Reg(29);
	if(i==0) // i!=0 showed that chip has been actived.so do not active again.
	SPI_Write_Reg(ACTIVATE_CMD,0x73);// Active
	for(i=22;i>=21;i--)
	SPI_Write_Reg((WRITE_REG|Bank0_Reg[i][0]),Bank0_Reg[i][1]);
	#ifdef bk2423
//********************Write Bank1 register******************
	SwitchCFG(1);
	for(i=0;i<=8;i++)//reverse
	{
		for(j=0;j<4;j++)
		WriteArr[j]=(Bank1_Reg0_13[i]>>(8*(j) ) )&0xff;
		SPI_Write_Buf((WRITE_REG|i),&(WriteArr[0]),4);
	}
	for(i=9;i<=13;i++)
	{
		for(j=0;j<4;j++)
		WriteArr[j]=(Bank1_Reg0_13[i]>>(8*(3-j) ) )&0xff;
		SPI_Write_Buf((WRITE_REG|i),&(WriteArr[0]),4);
	}
	SPI_Write_Buf((WRITE_REG|14),&(Bank1_Reg14[0]),11);
//toggle REG4<25,26>
	for(j=0;j<4;j++)
	WriteArr[j]=(Bank1_Reg0_13[4]>>(8*(j) ) )&0xff;
	WriteArr[0]=WriteArr[0]|0x06;
	SPI_Write_Buf((WRITE_REG|4),&(WriteArr[0]),4);
	WriteArr[0]=WriteArr[0]&0xf9;
	SPI_Write_Buf((WRITE_REG|4),&(WriteArr[0]),4);
	//DelayMs(10);
	Delay100ms();
	
//********************switch back to Bank0 register access******************
	SwitchCFG(0);
#endif

//	SwitchToRxMode();//switch to RX mode

}

void Send_Packet(UINT8 type,UINT8* pbuf,UINT8 len)
{
	SPI_Write_Buf(type, pbuf, len); // Writes data to buffer	
}

/**************************************************
Function: Receive_Packet
Description:
	read FIFO to read a packet
Parameter:
	None
Return:
	None
**************************************************/
void Receive_Packet()
{
	UINT8 len,sta,fifo_sta,t;
	UINT8 rx_buf[MAX_PACKET_LEN];

	sta=SPI_Read_Reg(STATUS);	// read register STATUS's value
	if(sta&STATUS_RX_DR)				// if receive data ready (RX_DR) interrupt
	{
		 
		do
		{
		    
			len=SPI_Read_Reg(R_RX_PL_WID_CMD);	// read len
			if(len<=MAX_PACKET_LEN)
			{
			    for(t=0;t<32;t++)
				rx_buf[t]=0;
				SPI_Read_Buf(RD_RX_PLOAD,rx_buf,len);// read receive payload from RX_FIFO buffer
				uartSendString(rx_buf);
			}
			else
			{
				SPI_Write_Reg(FLUSH_RX,0);//flush Rx
			}

			fifo_sta=SPI_Read_Reg(FIFO_STATUS);	// read register FIFO_STATUS's value
						
		}while((fifo_sta&FIFO_STATUS_RX_EMPTY)==0); //while not empty
	}

	SPI_Write_Reg(WRITE_REG|STATUS,sta);// clear RX_DR or TX_DS or MAX_RT interrupt flag
	
}



void SPI_CLR_Reg(BYTE R_T)
{
  	CSN = 0; 
	if(R_T==1)                  // CSN low, init SPI transaction
  	SPI_RW(FLUSH_TX);             // ..and write value to it..
	else
	SPI_RW(FLUSH_RX);             // ..and write value to it..
  	CSN = 1;                   // CSN high again
}

void ifnnrf_CLERN_ALL()
{
  SPI_CLR_Reg(0);
  SPI_CLR_Reg(1);
  SPI_RW_Reg(WRITE_REG+STATUS,0xff);
  IRQ=1;
}


